# Test cases index
* [Class diagrams](#class-diagrams)
* [Sequence diagrams](#sequence-diagrams)
* [Package diagrams](#package-diagrams)
* [Include diagrams](#include-diagrams)
* [Configuration diagrams](#configuration-diagrams)

## Class diagrams
 * [t00002](./test_cases/t00002.md) - Basic class inheritance
 * [t00003](./test_cases/t00003.md) - Class fields and methods
 * [t00004](./test_cases/t00004.md) - Nested classes and enums
 * [t00005](./test_cases/t00005.md) - Basic class field relationships
 * [t00006](./test_cases/t00006.md) - Class field relationships inferred from templates
 * [t00007](./test_cases/t00007.md) - Smart pointers
 * [t00008](./test_cases/t00008.md) - Template and template template relationships
 * [t00009](./test_cases/t00009.md) - Template instantiation
 * [t00010](./test_cases/t00010.md) - Basic template instantiation
 * [t00011](./test_cases/t00011.md) - Friend relationships
 * [t00012](./test_cases/t00012.md) - Advanced template instantiations
 * [t00013](./test_cases/t00013.md) - Template instantiation relationships
 * [t00014](./test_cases/t00014.md) - Alias template instantiation
 * [t00015](./test_cases/t00015.md) - Namespace fun
 * [t00016](./test_cases/t00016.md) - Unnamed enums and empty templates
 * [t00017](./test_cases/t00017.md) - Test include relations also as members flag
 * [t00018](./test_cases/t00018.md) - Pimpl pattern
 * [t00019](./test_cases/t00019.md) - Layercake pattern
 * [t00020](./test_cases/t00020.md) - Abstract factory pattern
 * [t00021](./test_cases/t00021.md) - Visitor pattern
 * [t00022](./test_cases/t00022.md) - Template method pattern
 * [t00023](./test_cases/t00023.md) - Strategy pattern
 * [t00024](./test_cases/t00024.md) - Proxy pattern
 * [t00025](./test_cases/t00025.md) - Template proxy pattern
 * [t00026](./test_cases/t00026.md) - Template memento pattern
 * [t00027](./test_cases/t00027.md) - Template decorator pattern
 * [t00028](./test_cases/t00028.md) - PlantUML note decorator test case
 * [t00029](./test_cases/t00029.md) - PlantUML skip decorator test case
 * [t00030](./test_cases/t00030.md) - PlantUML relationship decorators test case
 * [t00031](./test_cases/t00031.md) - PlantUML style decorator test case
 * [t00032](./test_cases/t00032.md) - Class template with template base classes test case
 * [t00033](./test_cases/t00033.md) - Nested template instantiation dependency test case
 * [t00034](./test_cases/t00034.md) - Template metaprogramming type function test case
 * [t00035](./test_cases/t00035.md) - PlantUML class diagram layout hints test case
 * [t00036](./test_cases/t00036.md) - Class diagram with namespaces generated as packages
 * [t00037](./test_cases/t00037.md) - Anonymous nested struct test case
 * [t00038](./test_cases/t00038.md) - Template instantiation with unexposed nested templates
 * [t00039](./test_cases/t00039.md) - Subclass class diagram filter test
 * [t00040](./test_cases/t00040.md) - Relationship and access filter test
 * [t00041](./test_cases/t00041.md) - Context diagram filter test
 * [t00042](./test_cases/t00042.md) - Specialization class template diagram filter test
 * [t00043](./test_cases/t00043.md) - Dependants and dependencies class diagram filter test
 * [t00044](./test_cases/t00044.md) - Test case for inner type aliases with parent class template args
 * [t00045](./test_cases/t00045.md) - Test case for root namespace handling
 * [t00046](./test_cases/t00046.md) - Test case for root namespace handling with packages
 * [t00047](./test_cases/t00047.md) - Test case for recursive variadic template
 * [t00048](./test_cases/t00048.md) - Test case for unique entity id with multiple translation units
 * [t00049](./test_cases/t00049.md) - Test case configurable type aliases
 * [t00050](./test_cases/t00050.md) - Test case for generating notes from comments using jinja templates
 * [t00051](./test_cases/t00051.md) - Test case for relative paths in lambda names
 * [t00052](./test_cases/t00052.md) - Test case for template methods rendering
 * [t00053](./test_cases/t00053.md) - Test case for `together` layout hint in class diagram
 * [t00054](./test_cases/t00054.md) - Test case for `together` layout hint in class diagram with rendered namespaces
 * [t00055](./test_cases/t00055.md) - Test case for `row` and `column` layout hints
 * [t00056](./test_cases/t00056.md) - Basic C++20 concepts test case
 * [t00057](./test_cases/t00057.md) - Test case C99/C11 translation units with structs and unions
 * [t00058](./test_cases/t00058.md) - Test case for concepts with variadic parameters and type aliases
 * [t00059](./test_cases/t00059.md) - Non-virtual abstract factory pattern using concepts test case
 * [t00060](./test_cases/t00060.md) - Parents (base classes) diagram filter test case
 * [t00061](./test_cases/t00061.md) - Paths diagram filter test case
 * [t00062](./test_cases/t00062.md) - Template specialization matching based on deduced context
 * [t00063](./test_cases/t00063.md) - Element types diagram filter test case
 * [t00064](./test_cases/t00064.md) - Template type list test case
 * [t00065](./test_cases/t00065.md) - Class diagram with packages from directory structure
 * [t00066](./test_cases/t00066.md) - Class fields and methods without grouping and sorting
 * [t00067](./test_cases/t00067.md) - Class method type filter test case
 * [t00068](./test_cases/t00068.md) - Context filter radius parameter test case
## Sequence diagrams
 * [t20001](./test_cases/t20001.md) - Basic sequence diagram test case
 * [t20002](./test_cases/t20002.md) - Free function sequence diagram test case
 * [t20003](./test_cases/t20003.md) - Function template sequence diagram test case
 * [t20004](./test_cases/t20004.md) - Function template instantiation sequence diagram test case
 * [t20005](./test_cases/t20005.md) - Class template basic sequence diagram
 * [t20006](./test_cases/t20006.md) - Class template specialization basic sequence diagram
 * [t20007](./test_cases/t20007.md) - Class template variadic argument list sequence diagram
 * [t20008](./test_cases/t20008.md) - Constexpr if sequence diagram test case
 * [t20009](./test_cases/t20009.md) - Smart pointer dereference call expression test case
 * [t20010](./test_cases/t20010.md) - Container sequence diagram test case
 * [t20011](./test_cases/t20011.md) - Recursive calls sequence diagram test case
 * [t20012](./test_cases/t20012.md) - Lambda expression call sequence diagram test case
 * [t20013](./test_cases/t20013.md) - Function and method arguments in sequence diagrams test case
 * [t20014](./test_cases/t20014.md) - Multiple translation units sequence diagram test case
 * [t20015](./test_cases/t20015.md) - Class exclusion by namespace in sequence diagram test case
 * [t20016](./test_cases/t20016.md) - Template method specialization sequence diagram test case
 * [t20017](./test_cases/t20017.md) - Test case for combine_free_functions_into_file_participants option
 * [t20018](./test_cases/t20018.md) - Recursive template sequence diagram test case
 * [t20019](./test_cases/t20019.md) - Curiously Recurring Template Pattern sequence diagram test case
 * [t20020](./test_cases/t20020.md) - If statement sequence diagram test case
 * [t20021](./test_cases/t20021.md) - Loop statements sequence diagram test case
 * [t20022](./test_cases/t20022.md) - Forward class declaration sequence diagram test case
 * [t20023](./test_cases/t20023.md) - Try/catch statement sequence diagram test case
 * [t20024](./test_cases/t20024.md) - Switch statement sequence diagram test case
 * [t20025](./test_cases/t20025.md) - Skip decorator sequence diagram test case
 * [t20026](./test_cases/t20026.md) - Virtual method call sequence diagram test case
 * [t20027](./test_cases/t20027.md) - Filter call expressions based on access test case
 * [t20028](./test_cases/t20028.md) - Conditional (ternary) '?:' operator test case
 * [t20029](./test_cases/t20029.md) - Combined feature sequence diagram test case
 * [t20030](./test_cases/t20030.md) - Constructor and operator call test case
 * [t20031](./test_cases/t20031.md) - Callee type sequence diagram filter test case
 * [t20032](./test_cases/t20032.md) - Return type generation option sequence diagram test case
 * [t20033](./test_cases/t20033.md) - Control statement text in sequence diagram test case
 * [t20034](./test_cases/t20034.md) - Test case for rendering all call chains from one activity to another (from_to)
 * [t20035](./test_cases/t20035.md) - from_to sequence diagram test case with free functions
 * [t20036](./test_cases/t20036.md) - Test case for rendering all call chains leading to an activity (to)
 * [t20037](./test_cases/t20037.md) - Test case checking if activities in static variable declarations appear only once
 * [t20038](./test_cases/t20038.md) - Sequence diagram comment decorator test case
## Package diagrams
 * [t30001](./test_cases/t30001.md) - Basic package diagram test case
 * [t30002](./test_cases/t30002.md) - Package dependency test case
 * [t30003](./test_cases/t30003.md) - Package deprecated attribute test case
 * [t30004](./test_cases/t30004.md) - PlantUML package decorators test case
 * [t30005](./test_cases/t30005.md) - Package namespace alias test case
 * [t30006](./test_cases/t30006.md) - Package split namespace test case
 * [t30007](./test_cases/t30007.md) - Package diagram layout hints test case
 * [t30008](./test_cases/t30008.md) - Dependants and dependencies package diagram filter test
 * [t30009](./test_cases/t30009.md) - Together layout hint test
 * [t30010](./test_cases/t30010.md) - Package diagram with packages from directory structure
 * [t30011](./test_cases/t30011.md) - Package diagram with packages from directory structure for plain C
## Include diagrams
 * [t40001](./test_cases/t40001.md) - Basic include graph diagram test case
 * [t40002](./test_cases/t40002.md) - Cyclic include graph diagram test case
 * [t40003](./test_cases/t40003.md) - Dependants and dependencies include diagram filter test
## Configuration diagrams
 * [t90000](./test_cases/t90000.md) - Basic config test
