# t20023 - Try/catch statement sequence diagram test case
## Config
```yaml
compilation_database_dir: ..
output_directory: diagrams
diagrams:
  t20023_sequence:
    type: sequence
    glob:
      - ../../tests/t20023/t20023.cc
    include:
      namespaces:
        - clanguml::t20023
    using_namespace:
      - clanguml::t20023
    start_from:
      - function: "clanguml::t20023::tmain()"
```
## Source code
File t20023.cc
```cpp
#include <stdexcept>

namespace clanguml {
namespace t20023 {

struct A {
    int a1() { return 1; }
    int a2() { return 2; }
    int a3() { return 3; }
    int a4() { return 3; }

    int a()
    {
        try {
            return a1();
        }
        catch (std::runtime_error &) {
            return a2();
        }
        catch (std::logic_error &) {
            return a3();
        }
        catch (...) {
            return a4();
        }
    }
};

int tmain()
{
    A a;

    int result{};

    result = a.a();

    return result;
}
}
}
```
## Generated PlantUML diagrams
![t20023_sequence](./t20023_sequence.svg "Try/catch statement sequence diagram test case")
## Generated Mermaid diagrams
![t20023_sequence](./t20023_sequence_mermaid.svg "Try/catch statement sequence diagram test case")
## Generated JSON models
```json
{
  "diagram_type": "sequence",
  "metadata": {
    "clang_uml_version": "0.4.1-11-g39d3e1f",
    "llvm_version": "Ubuntu clang version 16.0.6 (++20230710042027+7cbf1a259152-1~exp1~20230710162048.105)",
    "schema_version": 1
  },
  "name": "t20023_sequence",
  "participants": [
    {
      "id": "761552264135157511",
      "name": "clanguml::t20023::tmain()",
      "source_location": {
        "column": 5,
        "file": "../../tests/t20023/t20023.cc",
        "line": 29,
        "translation_unit": "../../tests/t20023/t20023.cc"
      },
      "type": "function"
    },
    {
      "id": "750638294800359616",
      "name": "clanguml::t20023::A",
      "source_location": {
        "column": 8,
        "file": "../../tests/t20023/t20023.cc",
        "line": 6,
        "translation_unit": "../../tests/t20023/t20023.cc"
      },
      "type": "class"
    }
  ],
  "sequences": [
    {
      "messages": [
        {
          "from": {
            "activity_id": "761552264135157511",
            "activity_name": "clanguml::t20023::tmain()",
            "participant_id": "761552264135157511",
            "participant_name": "clanguml::t20023::tmain()"
          },
          "name": "a()",
          "return_type": "int",
          "scope": "normal",
          "source_location": {
            "column": 14,
            "file": "../../tests/t20023/t20023.cc",
            "line": 35,
            "translation_unit": "../../tests/t20023/t20023.cc"
          },
          "to": {
            "activity_id": "530651320277188697",
            "activity_name": "clanguml::t20023::A::a()",
            "participant_id": "750638294800359616"
          },
          "type": "message"
        },
        {
          "activity_id": "530651320277188697",
          "branches": [
            {
              "messages": [
                {
                  "from": {
                    "activity_id": "530651320277188697",
                    "activity_name": "clanguml::t20023::A::a()",
                    "participant_id": "750638294800359616"
                  },
                  "name": "a1()",
                  "return_type": "int",
                  "scope": "normal",
                  "source_location": {
                    "column": 20,
                    "file": "../../tests/t20023/t20023.cc",
                    "line": 15,
                    "translation_unit": "../../tests/t20023/t20023.cc"
                  },
                  "to": {
                    "activity_id": "94135113932519208",
                    "activity_name": "clanguml::t20023::A::a1()",
                    "participant_id": "750638294800359616"
                  },
                  "type": "message"
                }
              ],
              "type": "main"
            },
            {
              "messages": [
                {
                  "from": {
                    "activity_id": "530651320277188697",
                    "activity_name": "clanguml::t20023::A::a()",
                    "participant_id": "750638294800359616"
                  },
                  "name": "a2()",
                  "return_type": "int",
                  "scope": "normal",
                  "source_location": {
                    "column": 20,
                    "file": "../../tests/t20023/t20023.cc",
                    "line": 18,
                    "translation_unit": "../../tests/t20023/t20023.cc"
                  },
                  "to": {
                    "activity_id": "2060438178899014465",
                    "activity_name": "clanguml::t20023::A::a2()",
                    "participant_id": "750638294800359616"
                  },
                  "type": "message"
                }
              ],
              "type": "catch"
            },
            {
              "messages": [
                {
                  "from": {
                    "activity_id": "530651320277188697",
                    "activity_name": "clanguml::t20023::A::a()",
                    "participant_id": "750638294800359616"
                  },
                  "name": "a3()",
                  "return_type": "int",
                  "scope": "normal",
                  "source_location": {
                    "column": 20,
                    "file": "../../tests/t20023/t20023.cc",
                    "line": 21,
                    "translation_unit": "../../tests/t20023/t20023.cc"
                  },
                  "to": {
                    "activity_id": "1776927259621603017",
                    "activity_name": "clanguml::t20023::A::a3()",
                    "participant_id": "750638294800359616"
                  },
                  "type": "message"
                }
              ],
              "type": "catch"
            },
            {
              "messages": [
                {
                  "from": {
                    "activity_id": "530651320277188697",
                    "activity_name": "clanguml::t20023::A::a()",
                    "participant_id": "750638294800359616"
                  },
                  "name": "a4()",
                  "return_type": "int",
                  "scope": "normal",
                  "source_location": {
                    "column": 20,
                    "file": "../../tests/t20023/t20023.cc",
                    "line": 24,
                    "translation_unit": "../../tests/t20023/t20023.cc"
                  },
                  "to": {
                    "activity_id": "1082587698374248813",
                    "activity_name": "clanguml::t20023::A::a4()",
                    "participant_id": "750638294800359616"
                  },
                  "type": "message"
                }
              ],
              "type": "catch"
            }
          ],
          "name": "try",
          "type": "break"
        }
      ],
      "start_from": {
        "id": 761552264135157511,
        "location": "clanguml::t20023::tmain()"
      }
    }
  ],
  "using_namespace": "clanguml::t20023"
}
```
