# t30009 - Together layout hint test
## Config
```yaml
compilation_database_dir: ..
output_directory: diagrams
diagrams:
  t30009_package:
    type: package
    glob:
      - ../../tests/t30009/t30009.cc
    include:
      namespaces:
        - clanguml::t30009
    using_namespace:
      - clanguml::t30009
    layout:
      One::A:
        - together: [One::C]
      Two::B:
        - together: [Two::C, Two::D]
```
## Source code
File t30009.cc
```cpp
namespace clanguml::t30009 {
namespace One {
namespace A {
}
namespace B {
}
namespace C {
}
namespace D {
}
}
namespace Two {
namespace A {
}
namespace B {
}
namespace C {
}
namespace D {
}
}
}

```
## Generated PlantUML diagrams
![t30009_package](./t30009_package.svg "Together layout hint test")
## Generated Mermaid diagrams
![t30009_package](./t30009_package_mermaid.svg "Together layout hint test")
## Generated JSON models
```json
{
  "diagram_type": "package",
  "elements": [
    {
      "display_name": "clanguml",
      "elements": [
        {
          "display_name": "clanguml::t30009",
          "id": "1266799397652663064",
          "is_deprecated": false,
          "name": "t30009",
          "source_location": {
            "column": 21,
            "file": "../../tests/t30009/t30009.cc",
            "line": 1,
            "translation_unit": "../../tests/t30009/t30009.cc"
          },
          "type": "namespace"
        }
      ],
      "id": "2174271399507040339",
      "is_deprecated": false,
      "name": "clanguml",
      "source_location": {
        "column": 11,
        "file": "../../tests/t30009/t30009.cc",
        "line": 1,
        "translation_unit": "../../tests/t30009/t30009.cc"
      },
      "type": "namespace"
    },
    {
      "display_name": "clanguml::t30009::One",
      "elements": [
        {
          "display_name": "clanguml::t30009::One::A",
          "id": "1189741240939898414",
          "is_deprecated": false,
          "name": "A",
          "source_location": {
            "column": 11,
            "file": "../../tests/t30009/t30009.cc",
            "line": 3,
            "translation_unit": "../../tests/t30009/t30009.cc"
          },
          "type": "namespace"
        },
        {
          "display_name": "clanguml::t30009::One::B",
          "id": "209763670816643341",
          "is_deprecated": false,
          "name": "B",
          "source_location": {
            "column": 11,
            "file": "../../tests/t30009/t30009.cc",
            "line": 5,
            "translation_unit": "../../tests/t30009/t30009.cc"
          },
          "type": "namespace"
        },
        {
          "display_name": "clanguml::t30009::One::C",
          "id": "946522260503371974",
          "is_deprecated": false,
          "name": "C",
          "source_location": {
            "column": 11,
            "file": "../../tests/t30009/t30009.cc",
            "line": 7,
            "translation_unit": "../../tests/t30009/t30009.cc"
          },
          "type": "namespace"
        },
        {
          "display_name": "clanguml::t30009::One::D",
          "id": "1181245940399690936",
          "is_deprecated": false,
          "name": "D",
          "source_location": {
            "column": 11,
            "file": "../../tests/t30009/t30009.cc",
            "line": 9,
            "translation_unit": "../../tests/t30009/t30009.cc"
          },
          "type": "namespace"
        }
      ],
      "id": "1187941209208108244",
      "is_deprecated": false,
      "name": "One",
      "source_location": {
        "column": 11,
        "file": "../../tests/t30009/t30009.cc",
        "line": 2,
        "translation_unit": "../../tests/t30009/t30009.cc"
      },
      "type": "namespace"
    },
    {
      "display_name": "clanguml::t30009::Two",
      "elements": [
        {
          "display_name": "clanguml::t30009::Two::A",
          "id": "986505573514384282",
          "is_deprecated": false,
          "name": "A",
          "source_location": {
            "column": 11,
            "file": "../../tests/t30009/t30009.cc",
            "line": 13,
            "translation_unit": "../../tests/t30009/t30009.cc"
          },
          "type": "namespace"
        },
        {
          "display_name": "clanguml::t30009::Two::B",
          "id": "2156827588463114203",
          "is_deprecated": false,
          "name": "B",
          "source_location": {
            "column": 11,
            "file": "../../tests/t30009/t30009.cc",
            "line": 15,
            "translation_unit": "../../tests/t30009/t30009.cc"
          },
          "type": "namespace"
        },
        {
          "display_name": "clanguml::t30009::Two::C",
          "id": "1653274432960093632",
          "is_deprecated": false,
          "name": "C",
          "source_location": {
            "column": 11,
            "file": "../../tests/t30009/t30009.cc",
            "line": 17,
            "translation_unit": "../../tests/t30009/t30009.cc"
          },
          "type": "namespace"
        },
        {
          "display_name": "clanguml::t30009::Two::D",
          "id": "263095551354153183",
          "is_deprecated": false,
          "name": "D",
          "source_location": {
            "column": 11,
            "file": "../../tests/t30009/t30009.cc",
            "line": 19,
            "translation_unit": "../../tests/t30009/t30009.cc"
          },
          "type": "namespace"
        }
      ],
      "id": "1940839474792549233",
      "is_deprecated": false,
      "name": "Two",
      "source_location": {
        "column": 11,
        "file": "../../tests/t30009/t30009.cc",
        "line": 12,
        "translation_unit": "../../tests/t30009/t30009.cc"
      },
      "type": "namespace"
    }
  ],
  "metadata": {
    "clang_uml_version": "0.4.1-11-g39d3e1f",
    "llvm_version": "Ubuntu clang version 16.0.6 (++20230710042027+7cbf1a259152-1~exp1~20230710162048.105)",
    "schema_version": 1
  },
  "name": "t30009_package",
  "relationships": [],
  "using_namespace": "clanguml::t30009"
}
```
