# t90000 - Basic config test
## Config
```yaml
compilation_database_dir: ..
output_directory: diagrams
diagrams:
  t90000_class:
    type: class
    plantuml:
      before:
        - 'class "Foo" as C_001'
        - 'class C_001 {'
        - ' +int value'
        - '}'
        - 'C_001 <|-- ArrayList'
        - 'note top of C_001: This is a very important class.'
        - 'note "This is a\nfloating note" as N1'
        - 'note "This note is connected\nto several objects." as N2'
        - 'C_001 .. N2'
        - 'N2 .. ArrayList'
        - 'class "Boo" as C_002'
        - 'class C_002 {'
        - '}'
    mermaid:
      before:
        - 'class C_001["Foo"]'
        - 'class C_001 {'
        - ' +int value'
        - '}'
        - 'C_001 <|-- ArrayList'
        - 'note for C_001 "This is a very important class."'
        - 'note "This is a\nfloating note"'
        - 'class C_002["Boo"]'
        - 'class C_002 {'
        - '}'

```
## Source code
File t90000.cc
```cpp

```
## Generated PlantUML diagrams
![t90000_class](./t90000_class.svg "Basic config test")
## Generated Mermaid diagrams
![t90000_class](./t90000_class_mermaid.svg "Basic config test")
## Generated JSON models
```json
{
  "diagram_type": "class",
  "elements": [],
  "metadata": {
    "clang_uml_version": "0.4.1-11-g39d3e1f",
    "llvm_version": "Ubuntu clang version 16.0.6 (++20230710042027+7cbf1a259152-1~exp1~20230710162048.105)",
    "schema_version": 1
  },
  "name": "t90000_class",
  "relationships": []
}
```
